/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of PeerfactSim.KOM.
 *
 * PeerfactSim.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement
public class SerializableRoadNetwork implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -8523360385937842443L;

	@XmlElement(name = "roadNetwork")
	private Map<String, SerializableRoadNetworkEdge> _roadNetwork;

	private SerializableRoadNetwork() {
	}

	public SerializableRoadNetwork(RoadNetwork pRoadNetwork) {
		_roadNetwork = new HashMap<>();
		for (RoadNetworkEdge edge : pRoadNetwork.getAvailableEdges()) {
			_roadNetwork.put(edge.getEdgeID(), new SerializableRoadNetworkEdge(edge));
		}
	}

	public List<SerializableRoadNetworkEdge> getAvailableEdges() {
		return new ArrayList<>(_roadNetwork.values());
	}
}
