/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of PeerfactSim.KOM.
 * 
 * PeerfactSim.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.uavsupport.communication;

/**
 * Interface simulating direct hardware connection from Base to UAVs.
 * 
 * @author Julian Zobel
 *
 */
public interface BaseToUAVInterface {
	/**
	 * Connect the UAV to the base.
	 * 
	 * @param uav
	 */
	public void connectUAVtoBase(UAVToBaseInterface uav);
	
	/**
	 * Disconnect UAV from base.
	 * 
	 * @param uav
	 */
	public void disconnectUAV(UAVToBaseInterface uav);

	/**
	 * Mark an already connected UAV to be ready for assignments.
	 * 
	 * @param uav
	 */
	public void readyUAV(UAVToBaseInterface uav);
}
